//+------------------------------------------------------------------+
//|                                                        .mq4 |
//|                                                           Dronov |
//|                                                  yokme@fxmail.ru |
//+------------------------------------------------------------------+
#property copyright "Dronov"
#property link      "yokme@fxmail.ru"

extern double Lot    = 0.1;       //  
extern int    SL     = 22;        //  
extern int    TP     = 10;        //   
extern int    LimLvl = 10;        //   Limit-

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
int init()
{
  Alert ("- ");
  return(0);
}
  
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+ 

//1.    ,     

int start()                                 //   
{
  for (int i=0; i<=OrdersTotal(); i++)      //  "        
  {                                         //   1 "
    if (OrderSelect(i<0,SELECT_BY_POS)==true) continue;
//1.1     
    double bid   =MarketInfo(Symbol(),MODE_BID);      //   Bid
    double ask   =MarketInfo(Symbol(),MODE_ASK);      //   Ask
    double point =MarketInfo(Symbol(),MODE_POINT);    //  Point
 
//1.2   BUY    
    OrderSend(Symbol(),OP_BUY,Lot,ask,0,ask-SL*Point,ask+TP*Point,NULL,0);
    Alert (GetLastError());                      //   
    RefreshRates();                              //  
       
    string sy=Symbol();
    int mn=OrderMagicNumber();
    OrderSend(Symbol(),OP_BUYLIMIT,Lot,PriceOpenLastPos(sy,mn-1)-LimLvl*Point,0,PriceOpenLastPos(sy,mn-1)+TP*Point,PriceOpenLastPos(sy,mn-1)-SL*Point,NULL,0);
    Alert (GetLastError());                      //   
                                                 //  
  }
  return;                                        //    
} 

//2.     
double PriceOpenLastPos(string sy="",int mn=-1)
{
  datetime t;
  double   r=0;
  int      i, k=OrdersTotal();
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (t<OrderOpenTime()) {
              t=OrderOpenTime();
              r=OrderOpenPrice();
            }
          }
        }
      }
    }
  }
  return(r);
}

//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
int deinit()
{
  Alert ("- ");
  return(0);
}